


/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#define X4SVERSION "4.0"

#include <qapplication.h>
#include <qmessagebox.h>
#include <qinputdialog.h>
#include <qdatastream.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qtextstream.h>
#include <qdatetime.h>
#include <ctype.h>
#include <cstdlib>
#if QT_VERSION >= 0x40000	// For QT4 compatibility and shit
#include <q3valuevector.h>
#define QValueVector Q3ValueVector
#define QListBoxItem Q3ListBoxItem
#else
#include <qvaluevector.h>
#endif

#if defined(Q_WS_WIN)
 #if defined(_M_AMD64)
  #define OpSys " Win64"
 #else
  #define OpSys " Win32"
 #endif
#elif defined(Q_WS_MACX)
 #define OpSys " Mac OS X"
#else
 #define OpSys " X11"
#endif

/* No longer necessary since we're no longer using the STL file structures 
#define _RWSTD_NO_EXCEPTIONS // Otherwise we get an error in Borland C++
#include <fstream>
#include <vector> */
#define max(a,b) ((a) > (b) ? (a) : (b))
#define min(a,b) ((a) > (b) ? (b) : (a))
#define DEBUG
#ifdef DEBUG
#define msgboxd(x) msgbox((QString)x)
#else
#define msgboxd(x)
#endif


uchar *xm;	// This is much better off being read as unsigned
int xmsize;
int xmchannels;
int voices_in_xm;
uchar *rawvoices_file;
QValueVector<uchar> voices;
QValueVector<uchar> fmvoices;
QValueVector<uchar> psgvoices;
QValueVector<uchar> dacsamples;
QValueVector<bool> noisevoices;
QValueVector<QValueVector<QValueVector<uchar> > > xmdata;

QString itoa(int x) {
    return QString::number(x);
}
QString itoa(int x, int y) {
    return QString::number(x,y);
}

uchar *vector2array(QValueVector<uchar> vec) {
	uint vsize=vec.size();
	uchar *array = new uchar[vsize];
	for (uint i=0; i<vsize; ++i)
		array[i]=vec.at(i);
	return array;
}
	
bool compare_patterns(ushort ch, ushort pat1, ushort pat2) {
    if (xmdata.at(pat1).at(ch).size()!=xmdata.at(pat2).at(ch).size()) return false;
    
    for (ushort i=0; i<(ushort)(xmdata.at(pat1).at(ch).size()); ++i)
	if (xmdata.at(pat1).at(ch).at(i) != xmdata.at(pat2).at(ch).at(i)) return false;
    
    return true;
}

void frmMain::cmdBrowse_clicked()
{
	QString filename = QFileDialog::getOpenFileName(".", "eXtended Modules (*.xm)",
							this,
							"Please select the XM file you want to convert",
							"Please select the XM file you want to convert");	
	if (filename != "") {
		txtFilename->setText(filename);
		if (xm) 
			delete xm; // If we already have an XM allocated, free it.
		
/*
  		// Old code - now obsolete since QT's file and stream structures are being used instead
  
		std::ifstream xmfile (filename.ascii(), std::ios::binary|std::ios::ate);
		
		xmsize = xmfile.tellg();
		xm = new char[xmsize];
		xmfile.seekg(0, std::ios::beg);
		xmfile.read(xm,xmsize);
		xmfile.close();
		
		
*/		
		QFile file(filename);
		xmsize = file.size();
		xm = new uchar[xmsize];
		file.open(IO_ReadOnly);
		QDataStream stream(&file);
		stream.readRawBytes((char*)xm,xmsize);
		file.close();
		
		QString sizestr;
		sizestr.setNum(xmsize);
		sizestr+=" bytes";

		lblFilename->setText(filename);
		lblFilesize->setText(sizestr);
		
		char *cstr;
		cstr = new char[16];
		unsigned short int i;		
		for (i=0; i<15; ++i) 
			cstr[i] = xm[i];
		cstr[15]=0;
		QString ID(cstr);
		delete cstr;
		
		if (ID!="Extended Module") { // What the user loaded is NOT an XM
		    	delete xm;
			lblFilename->setText("");
			lblFilesize->setText("");
			xm = NULL;
			QMessageBox::critical(this,
					      "Error", 
					      "You're doing it wrong! " \
					      "File " + filename + " is not an XM.");
			return;
		}
		cstr = new char[21];

		for (i=0; i<20; ++i) 
			cstr[i] = xm[38+i];
		cstr[20] = 0;
		lblTracker->setText(cstr);
		
		for (i=0; i<20; ++i) 
			cstr[i] = xm[17+i];
		cstr[20] = 0;
		lblSongTitle->setText(cstr);
		delete cstr;
		
		float vnum = xm[59];
		vnum+= (float)xm[58]/10;
		QString n;
		lblXMversion->setText(itoa(vnum));
		lblLoop->setText(itoa(xm[66]));
		lblChannels->setText(itoa(xm[68]));
		lblPatterns->setText(itoa((xm[70] ? xm[70] : 256)));
		lblTempo->setText(itoa(xm[78]) + "/" + itoa(xm[76]));
		

		n = "";
		for (i=0; i<xm[64]; ++i) {
			n += itoa(xm[80+i]);
			n += ' ';
		}
		//n+='\0';
		lblPatternOrder->setText(n);
		cmbFM_1->clear();
		cmbFM_2->clear();
		cmbFM_3->clear();
		cmbFM_4->clear();
		cmbFM_5->clear();
		cmbFM_6->clear();
		cmbPSG_1->clear();
		cmbPSG_2->clear();
		cmbPSG_3->clear();
		cmbDAC->clear();
		
		for (i=1; i<=xm[68]; ++i) {
			cmbFM_1->insertItem(itoa(i));
			cmbFM_2->insertItem(itoa(i));
			cmbFM_3->insertItem(itoa(i));
			cmbFM_4->insertItem(itoa(i));
			cmbFM_5->insertItem(itoa(i));
			cmbFM_6->insertItem(itoa(i));
			cmbPSG_1->insertItem(itoa(i));
			cmbPSG_2->insertItem(itoa(i));
			cmbPSG_3->insertItem(itoa(i));
			cmbDAC->insertItem(itoa(i)); 
		}
		
		cmbFM_1->insertItem(" ");
		cmbFM_2->insertItem(" ");
		cmbFM_3->insertItem(" ");
		cmbFM_4->insertItem(" ");
		cmbFM_5->insertItem(" ");
		cmbFM_6->insertItem(" ");
		cmbPSG_1->insertItem(" ");
		cmbPSG_2->insertItem(" ");
		cmbPSG_3->insertItem(" ");
		cmbDAC->insertItem(" "); 
		
		cmbFM_1->setCurrentItem(i-1);
		cmbFM_2->setCurrentItem(i-1);
		cmbFM_3->setCurrentItem(i-1);
		cmbFM_4->setCurrentItem(i-1);
		cmbFM_5->setCurrentItem(i-1);
		cmbFM_6->setCurrentItem(i-1);
		cmbPSG_1->setCurrentItem(i-1);
		cmbPSG_2->setCurrentItem(i-1);
		cmbPSG_3->setCurrentItem(i-1);
		cmbDAC->setCurrentItem(i-1); 
		
		
	}
}



int main (int argc, char **argv) {
	QApplication a (argc, argv);
	frmMain *mainwin = new frmMain();
	a.setMainWidget(mainwin);
	mainwin->show();
	return a.exec();
}





void frmMain::sliderFMs_sliderMoved(int num)
{
	QString s = "0";
	s[0] = '0'+num;
	lblFMs->setText(s);
	
	cmbFM_1->setEnabled(false);
	cmbFM_2->setEnabled(false);
	cmbFM_3->setEnabled(false);
	cmbFM_4->setEnabled(false);
	cmbFM_5->setEnabled(false);
	cmbFM_6->setEnabled(false);
	
	lblFM1->setEnabled(false);
	lblFM2->setEnabled(false);
	lblFM3->setEnabled(false);
	lblFM4->setEnabled(false);
	lblFM5->setEnabled(false);
	lblFM6->setEnabled(false);

	fraFM1->setEnabled(false);
	fraFM2->setEnabled(false);
	fraFM3->setEnabled(false);
	fraFM4->setEnabled(false);
	fraFM5->setEnabled(false);
	fraFM6->setEnabled(false);
	
	
	switch (num) {
	case 6:
		fraFM6->setEnabled(true);
		lblFM6->setEnabled(true);
		cmbFM_6->setEnabled(true);
	case 5:
		fraFM5->setEnabled(true);
		lblFM5->setEnabled(true);
		cmbFM_5->setEnabled(true);
	case 4:
		fraFM4->setEnabled(true);
		lblFM4->setEnabled(true);
		cmbFM_4->setEnabled(true);
	case 3:
		fraFM3->setEnabled(true);
		lblFM3->setEnabled(true);
		cmbFM_3->setEnabled(true);
	case 2:
		fraFM2->setEnabled(true);
		lblFM2->setEnabled(true);
		cmbFM_2->setEnabled(true);
	case 1:
		fraFM1->setEnabled(true);
		lblFM1->setEnabled(true);
		cmbFM_1->setEnabled(true);
	}

}
void frmMain::chkDAC_clicked()
{
	if (chkDAC->isChecked()) {
		sliderFMs->setMaxValue(5);
		if (sliderFMs->value() == 5) 
			lblFMs->setText("5");
		lblDAC->setEnabled(true);
		cmbDAC->setEnabled(true);
		lblFM6->setEnabled(false);
		cmbFM_6->setEnabled(false);
		fraDAC->setEnabled(true);
		grpDAC->setEnabled(true);
	}
	else {
		sliderFMs->setMaxValue(6);
		lblDAC->setEnabled(false);
		cmbDAC->setEnabled(false);
		fraDAC->setEnabled(false);
		grpDAC->setEnabled(false);
	
	}
}


void frmMain::sliderPSGs_sliderMoved(int num)
{
	QString s = "0";
	s[0] = '0'+num;
	lblPSGs->setText(s);
	
	lblPSG1->setEnabled(false);
	lblPSG2->setEnabled(false);
	lblPSG3->setEnabled(false);
	
	fraPSG1->setEnabled(false);
	fraPSG2->setEnabled(false);
	fraPSG3->setEnabled(false);
	
	cmbPSG_1->setEnabled(false);
	cmbPSG_2->setEnabled(false);
	cmbPSG_3->setEnabled(false);
	
	
	switch (num) {
	case 3:
		fraPSG3->setEnabled(true);
		lblPSG3->setEnabled(true);
		cmbPSG_3->setEnabled(true);
	case 2:
		fraPSG2->setEnabled(true);
		lblPSG2->setEnabled(true);
		cmbPSG_2->setEnabled(true);
	case 1:
		fraPSG1->setEnabled(true);
		lblPSG1->setEnabled(true);
		cmbPSG_1->setEnabled(true);
	}

	updatePSGNoise(num);
}


void frmMain::chkLoop_clicked()
{
	chkE4->setEnabled(!chkLoop->isChecked());
}

void frmMain::updatePSGNoise(int n) {
	if (chkPSGNoise->isChecked()) {
		grpNoise->setEnabled(true);
		switch (n) {
		case 3:
			lblPSG3->setText("Noise");
			lblPSG2->setText("PSG2");
			lblPSG1->setText("PSG1");
			lblfrPSG3->setText("Noise:");
			lblfrPSG2->setText("PSG 2:");
			lblfrPSG1->setText("PSG 1:");
			
			break;
		case 2:
			lblPSG3->setText("PSG3");
			lblPSG2->setText("Noise");
			lblPSG1->setText("PSG1");
			lblfrPSG2->setText("Noise:");
			lblfrPSG3->setText("PSG 3:");
			lblfrPSG1->setText("PSG 1:");
			
			break;
		case 1:
			lblPSG3->setText("PSG3");
			lblPSG2->setText("PSG2");
			lblPSG1->setText("Noise");
			lblfrPSG1->setText("Noise:");
			lblfrPSG2->setText("PSG 2:");
			lblfrPSG3->setText("PSG 3:");
			
			break;
		}
	}
	else {
		grpNoise->setEnabled(false);		
		lblPSG1->setText("PSG1");
		lblPSG2->setText("PSG2");
		lblPSG3->setText("PSG3");
	}	
}
void frmMain::chkPSGNoise_clicked()
{		
	updatePSGNoise(sliderPSGs->value());
}


void frmMain::cmdBrowseVoices_clicked()
{
	QString filename;
	QFileDialog ofn	(this, "Please select the voice file you want to load");
	ofn.setMode(QFileDialog::ExistingFile);
	ofn.setViewMode(QFileDialog::Detail);
/*	ofn.setFilter("xm3smps voice files (*.x3v)");
	ofn.addFilter("SMPS raw voices (*.bin)");
	ofn.addFilter("Sonic 2 raw voices (*.bin)");
	ofn.addFilter("Sonic QX voice files (*.ymx)");
	ofn.addFilter("TFM Music Maker instruments (*.tfi)");
	ofn.addFilter("MVS Tracker instruments (*.ins)");
	ofn.addFilter("Rip from SMPS 68K Song (*.bin)");
	ofn.addFilter("Rip from SMPS Z80 Song (*.bin)");	*/
	QStringList types;
	types	<< "xm3smps voice files (*.x3v)"
	 	<< "SMPS raw voices (*.bin)"
		<< "Sonic 2 raw voices (*.bin)"
		<< "Sonic QX voice files (*.ymx)"
		<< "TFM Music Maker instruments (*.tfi)"
		<< "MVS Tracker instruments (*.ins)"
		<< "Rip from SMPS 68K Song (*.bin)"
		<< "Rip from SMPS Z80 Song (*.bin)";
	ofn.setFilters(types);
#if QT_VERSION >= 0x40000	// For QT4 compatibility and shit
	ofn.selectFilter("xm4smps voice files (*.x3v)");
#else
	ofn.setSelectedFilter("xm4smps voice files (*.x3v)"); // Set default filter to x3v 
#endif
/*	filename=ofn.getOpenFileName(".",QString::null,this, 
				     "open file dialog", 
				     "Please select the XM file you want to convert"); */
	if (ofn.exec() == QDialog::Accepted)
		filename = ofn.selectedFile();
	else	
		return;
	txtVoiceFile->setText(filename);
	lstVoicesFile->clear();
	QFile voicefile(filename);
	uint voicefile_size = voicefile.size();
	if (rawvoices_file) delete rawvoices_file;
	uchar *voice_file = new uchar[voicefile_size];
	voicefile.open(IO_ReadOnly);
	QDataStream stream(&voicefile);
	stream.readRawBytes((char*)voice_file,voicefile_size);
	voicefile.close();
	QString filter = ofn.selectedFilter();
	if (filter=="SMPS raw voices (*.bin)") {
		// Raw SMPS voice filter
		rawvoices_file = voice_file;
		QString basefilename;
		basefilename = filename.right(filename.length()-filename.findRev("/")-1);
		for (uint i=0; i<voicefile_size/0x19; ++i) { //Read all voices into the array
			lstVoicesFile->insertItem("Voice " + itoa(i) + " from " + basefilename);
		}
		
	}
	else if (filter=="xm3smps voice files (*.x3v)") {
		// x3v voice filter
		uchar numvoices=voice_file[0];
		rawvoices_file = new uchar[numvoices*0x19];
		voice_file++;
		for (uchar i=0; i<numvoices; ++i) {
			for (uchar j=0; j<0x19; ++j)
				rawvoices_file[i*0x19+j]=*(voice_file++);
			uchar numbytes_name = *(voice_file++);
			QString name_voice = "";
			for (uchar j=0; j<numbytes_name; ++j)
				name_voice += *(voice_file++);
			lstVoicesFile->insertItem(name_voice);
			
		}
		delete voice_file; // Remove the x3v from memory, now that it has been loaded
	}
	else if (filter=="Sonic QX voice files (*.ymx)") {
		// ymx voice filter
		ushort numvoices=voice_file[7]+1;
		rawvoices_file = new uchar[numvoices*0x19];
		if (!numvoices) {
			QMessageBox::critical(this,"Error", "This YMX is empty!");
			return;
		}
		QString id="";
		for (uchar i=0; i<6; ++i)
			id+=voice_file[i];
		if (id!="YM2612") {
			QMessageBox::critical(this,"Error", "This file is not a valid YMX!");
			return;
		}
		voice_file +=8; // Skip 8 bytes
		for (ushort i=0; i<numvoices; ++i) {
			uchar voice[0x19]; // I hate byteswapping :/
			voice[0] = voice_file[0];
			voice[1] = voice_file[1];
			voice[2] = voice_file[3];
			voice[3] = voice_file[2];
			voice[4] = voice_file[4];
			voice[5] = voice_file[5];
			voice[6] = voice_file[7];
			voice[7] = voice_file[6];
			voice[8] = voice_file[8];
			voice[9] = voice_file[9];
			voice[0xA] = voice_file[0xB];
			voice[0xB] = voice_file[0xA];
			voice[0xC] = voice_file[0xC];
			voice[0xD] = voice_file[0xD];
			voice[0xE] = voice_file[0xF];
			voice[0xF] = voice_file[0xE];
			voice[0x10] = voice_file[0x10];
			voice[0x11] = voice_file[0x11];
			voice[0x12] = voice_file[0x13];
			voice[0x13] = voice_file[0x12];
			voice[0x14] = voice_file[0x14];
			voice[0x15] = voice_file[0x15];
			voice[0x16] = voice_file[0x17];
			voice[0x17] = voice_file[0x16];
			voice[0x18] = voice_file[0x18];		
			voice_file+=0x19; // Advance pointer... yeah I'm actually using pointers here :O
			QString name_voice = "";
			for (uchar j=0; j<10; ++j) 
				if (*voice_file)
					name_voice+=*(voice_file++);
				else
					voice_file++;
			name_voice = name_voice.simplifyWhiteSpace(); // Strip extra spaces
			for (uchar j=0; j<0x19; ++j)
				rawvoices_file[i*0x19+j]=voice[j];
			lstVoicesFile->insertItem(name_voice);			
		}
		delete voice_file;
	}
	else if (filter=="Rip from SMPS 68K Song (*.bin)") {
		// SMPS 68K song rip filter
		/* 
		 * Short description:
                 * - Get the pointer to the voices, 
                 * - Add it to the file pointer
                 * - Subtract from size
                 * - Copy raw smps reader for the rest
                 */
		ushort ptr = ((ushort)voice_file[0]<<8) + voice_file[1];
		voice_file += ptr;
		voicefile_size -= ptr; 
		// Recycling the raw smps reader now
		rawvoices_file = voice_file;
		QString basefilename;
		basefilename = filename.right(filename.length()-filename.findRev("/")-1);
		for (uint i=0; i<voicefile_size/0x19; ++i) { //Read all voices into the array
			lstVoicesFile->insertItem("Voice " + itoa(i) + " ripped from " + basefilename);
		}
		
	}
	else if (filter=="Sonic 2 raw voices (*.bin)") {
		// Sonic 2 voice filter
		// Byteswapping... again :/
		uint numvoices = voicefile_size/0x19;
		rawvoices_file = new uchar[numvoices*0x19];
		QString basefilename = filename.right(filename.length()-filename.findRev("/")-1);
		for (uint i=0; i<numvoices; ++i) {
			uchar voice[0x19]; // I hate byteswapping :/
			voice[0] = voice_file[0];
			voice[1] = voice_file[1];
			voice[2] = voice_file[3];
			voice[3] = voice_file[2];
			voice[4] = voice_file[4];
			voice[5] = voice_file[5];
			voice[6] = voice_file[7];
			voice[7] = voice_file[6];
			voice[8] = voice_file[8];
			voice[9] = voice_file[9];
			voice[0xA] = voice_file[0xB];
			voice[0xB] = voice_file[0xA];
			voice[0xC] = voice_file[0xC];
			voice[0xD] = voice_file[0xD];
			voice[0xE] = voice_file[0xF];
			voice[0xF] = voice_file[0xE];
			voice[0x10] = voice_file[0x10];
			voice[0x11] = voice_file[0x11];
			voice[0x12] = voice_file[0x13];
			voice[0x13] = voice_file[0x12];
			voice[0x14] = voice_file[0x14];
			voice[0x15] = voice_file[0x15];
			voice[0x16] = voice_file[0x17];
			voice[0x17] = voice_file[0x16];
			voice[0x18] = voice_file[0x18];		
			voice_file+=0x19; // Advance pointer... yeah I'm actually using pointers here :O	
			for (uchar j=0; j<0x19; ++j)
				rawvoices_file[i*0x19+j]=voice[j];
			
			lstVoicesFile->insertItem("S2 Voice " + itoa(i) + " from " + basefilename);
		}
			
	}
	else if (filter=="Rip from SMPS Z80 Song (*.bin)") {
		// SMPS Z80 song rip filter
		// This one's gonna be a bitch I bet
		ushort voiceptr = ((ushort)voice_file[1]<<8) + voice_file[0];
		
		ushort ptr = ((ushort)voice_file[7]<<8)+voice_file[6];
		ushort minptr = min(voiceptr,ptr);
	
		uchar numfms = voice_file[2]-1;
		uchar numpsgs = voice_file[3];
		
		for (uchar i=0; i<numfms; ++i) {
			ptr = ((ushort)voice_file[0xB+(i*4)]<<8)+voice_file[0xA+(i*4)];
			minptr = min(ptr,minptr);
		}
		
		for (uchar i=0; i<numpsgs; ++i) {
			ptr = ((ushort)voice_file[0xB+(numfms*4)+(i*6)]<<8)+voice_file[0xA+(numfms*4)+(i*6)];
			minptr = min(ptr,minptr);
		}
		minptr -= 0xA+(numfms*4)+(numpsgs*6);
		voiceptr -= minptr; // K we're done with this shit :/
		
		voice_file += voiceptr;
		voicefile_size -= voiceptr; 
		// Recycling the raw smps reader now
		rawvoices_file = voice_file;
		QString basefilename;
		basefilename = filename.right(filename.length()-filename.findRev("/")-1);
		for (uint i=0; i<voicefile_size/0x19; ++i) { //Read all voices into the array
			lstVoicesFile->insertItem("Voice " + itoa(i) + " ripped from " + basefilename);
		}
		
	}
	else if (filter=="MVS Tracker instruments (*.ins)") {	
		// MVS Tracker ".ins" filter
		QString id="";
		for (uchar i=0; i<5; ++i)
			id+=*(voice_file++);
		if (id.lower() != "mvsi1") {
			QMessageBox::critical(this,"Error", "This file isn't an MVS!");
			return;
		}
		rawvoices_file = new uchar[0x19];
		while (*(voice_file++));
		
		rawvoices_file[0]=voice_file[0x18];
    
		rawvoices_file[1]=voice_file[0];
		rawvoices_file[2]=voice_file[2];
		rawvoices_file[3]=voice_file[1];
		rawvoices_file[4]=voice_file[3];
		
		rawvoices_file[5]=voice_file[8];
		rawvoices_file[6]=voice_file[0xA];
		rawvoices_file[7]=voice_file[9];
		rawvoices_file[8]=voice_file[0xB];
		
		rawvoices_file[9]=voice_file[0xC];
		rawvoices_file[0xA]=voice_file[0xE];
		rawvoices_file[0xB]=voice_file[0xD];
		rawvoices_file[0xC]=voice_file[0xF];
		
		rawvoices_file[0xD]=voice_file[0x10];
		rawvoices_file[0xE]=voice_file[0x12];
		rawvoices_file[0xF]=voice_file[0x11];
		rawvoices_file[0x10]=voice_file[0x13];
		
		rawvoices_file[0x11]=voice_file[0x14];
		rawvoices_file[0x12]=voice_file[0x16];
		rawvoices_file[0x13]=voice_file[0x15];
		rawvoices_file[0x14]=voice_file[0x17];
		
		rawvoices_file[0x15]=voice_file[4];
		rawvoices_file[0x16]=voice_file[6];
		rawvoices_file[0x17]=voice_file[5];
		rawvoices_file[0x18]=voice_file[7];
		delete voice_file;
		QString basefilename;
		basefilename = filename.right(filename.length()-filename.findRev("/")-1);
		lstVoicesFile->insertItem(basefilename);
		
	}
	else if (filter=="TFM Music Maker instruments (*.tfi)") {
		// TFM Music Maker "tfi" instrument filter
		if (voice_file[1] | voice_file[11] | voice_file[21] | voice_file[31])
			QMessageBox::warning(this,"Warning", "This voice uses the SSG-EG, so it might sound wrong in SMPS!");
		rawvoices_file = new uchar[0x19];
		
		rawvoices_file[0x00]=voice_file[0]+(voice_file[1]<<3);
		
		rawvoices_file[0x04]=voice_file[32]+((voice_file[33]-3)<<4);
		rawvoices_file[0x02]=voice_file[22]+((voice_file[23]-3)<<4);
		rawvoices_file[0x03]=voice_file[12]+((voice_file[13]-3)<<4);
		rawvoices_file[0x01]=voice_file[02]+((voice_file[03]-3)<<4);
		
		rawvoices_file[0x08]=voice_file[36]+(voice_file[35]<<6);
		rawvoices_file[0x06]=voice_file[26]+(voice_file[25]<<6);
		rawvoices_file[0x07]=voice_file[16]+(voice_file[15]<<6);
		rawvoices_file[0x05]=voice_file[06]+(voice_file[05]<<6);
		
		rawvoices_file[0x0C]=voice_file[37];
		rawvoices_file[0x0A]=voice_file[27];
		rawvoices_file[0x0B]=voice_file[17];
		rawvoices_file[0x09]=voice_file[07];
		
		rawvoices_file[0x10]=voice_file[38];
		rawvoices_file[0x0E]=voice_file[28];
		rawvoices_file[0x0F]=voice_file[18];
		rawvoices_file[0x0D]=voice_file[8];
		
		rawvoices_file[0x14]=voice_file[39]+(voice_file[40]<<4);
		rawvoices_file[0x12]=voice_file[29]+(voice_file[30]<<4);
		rawvoices_file[0x13]=voice_file[19]+(voice_file[20]<<4);
		rawvoices_file[0x11]=voice_file[9]+(voice_file[10]<<4);
		
		rawvoices_file[0x18]=voice_file[34];
		rawvoices_file[0x16]=voice_file[24];
		rawvoices_file[0x17]=voice_file[14];
		rawvoices_file[0x15]=voice_file[4];
		delete voice_file;
		QString basefilename;
		basefilename = filename.right(filename.length()-filename.findRev("/")-1);
		lstVoicesFile->insertItem(basefilename);
		
		
	}
	else
		QMessageBox::critical(this,"Error", "The filter for " \
				      + ofn.selectedFilter() + \
				      " isn't done yet D:");
	
}

#define Compiler "Unknown compiler"
	
#ifdef __GNUC__
#undef Compiler
#define Compiler "GNU C++ Compiler " \
		+ itoa(__GNUC__) + "." \
		+ itoa(__GNUC_MINOR__ ) + "." \
		+ itoa(__GNUC_PATCHLEVEL__)
#endif
		
#ifdef _MSC_VER
#undef Compiler
#define Compiler "Microsoft Visual C++ " + itoa((_MSC_VER/100)-6) + "." + itoa((_MSC_VER/10)%10) // Visual C++ 1 was _MSC_VER = 7
#endif
		
#ifdef __BORLANDC__
#undef Compiler	
#define Compiler "Borland C++ Compiler " + parseBCBversion(__BORLANDC__)
			
QString parseBCBversion(int bcbver) {
	QString blah = itoa(bcbver,16);		// Borland C++'s version is in hex
	QString blargh = blah.at(0) + "." + blah.at(1) + "." + blah.at(2);
	return blargh;
}
	
					
		
#endif
	
			
void frmMain::init() {
	
	lblWords->setText(lblWords->text() + "\nThis software uses Qt " QT_VERSION_STR OpSys ". Qt is  Trolltech.\nCompiled using " Compiler + " on " __DATE__ ".");
	setCaption("Puto's XM to SMPS converter v" X4SVERSION);
	lblXM4SMPS->setText("XM4SMPS v" X4SVERSION);
#ifdef Q_WS_MACX
//#if 1
	setCaption("XM4SMPS");
//	chkNoteNums->setFont(new QFont("Lucida Grande",10));
//	chkPSGNoteNums->setFont(new QFont("Lucida Grande",10));
#endif
	fmvoices.resize(255);
	psgvoices.resize(255);
	dacsamples.resize(255);
	noisevoices.resize(255);
	for (uchar i=0; i<0xFF; ++i) {
		lstFMInstr->insertItem(itoa((int)i+1));
		lstPSGInstr->insertItem(itoa((int)i+1));
		lstFMVoice->insertItem(itoa((int)i));
		lstPSGVoice->insertItem(itoa((int)i));
		fmvoices.at(i) = i;
	}
	lstFMVoice->insertItem(itoa((int)0xFF));
	lstPSGVoice->insertItem(itoa((int)0xFF));
	chkNoteNums_toggled(false);
	chkPSGNoteNums_toggled(false);
	
}


void frmMain::msgbox (QString msg) {
	QMessageBox::information(this,"XM4SMPS",msg);
}

void frmMain::msgbox (QString msg, QString title) {
	QMessageBox::information(this,title,msg);
}

void frmMain::cmdAutoFill_clicked()
{
	if (!xm) {
		QMessageBox::critical(this,"Error", "You are a gigantic faggot. Load an XM first, nigga!");
		return;
	}
	
	char oc4=0,oc3=0,oc2=0,oc1=0;
	uint i;
	for (i=xmsize; i; --i) {
		oc4=oc3;
		oc3=oc2;
		oc2=oc1;
		oc1=xm[i];
		if (oc1 == 'C' && oc2 == 'N' && oc3 == 'A' && oc4 == 'M') break;
	}
	if (!i) {
		QMessageBox::critical(this,"Error", "You're doing it wrong! Your XM doesn't have channel names!");
		return;
	}
	QString *cnam;
	cnam = new QString[xm[68]];
	for (int x=0; x<xm[68]; ++x) {
		cnam[x] = "";
	}
	uint j=i+5;
	for (int x=0; x<xm[68]; ++x) {
		uint n=0;
		while (n < 20) {
			if (xm[j+n]) cnam[x] += xm[j+n];
			n++;
		}
		j+=20;
	}
		
	//for (short int x=0; x<xm[68]; ++x) 
	//	QMessageBox::critical(this,(QString)"Channel " + x + " name", " lol -> " + cnam[x]);
	//QString blah;
	//blah.setNum(i);
	//QMessageBox::critical(this,"yo", "CNAM is at " + blah);	
	char FMs=0,PSGs=0,DAC=0,NoiseChannel=-1;
	for (short int x=0; x<xm[68]; ++x) {
		QString n=cnam[x].upper();
		if (n.left(3)=="FM1") {
			FMs=max(FMs,1);
			cmbFM_1->setCurrentItem(x);
		}
		else if (n.left(3)=="FM2") {
			FMs=max(FMs,2);
			cmbFM_2->setCurrentItem(x);
		}
		else if (n.left(3)=="FM3") {
			FMs=max(FMs,3);
			cmbFM_3->setCurrentItem(x);
		}
		else if (n.left(3)=="FM4") {
			FMs=max(FMs,4);
			cmbFM_4->setCurrentItem(x);
		}
		else if (n.left(3)=="FM5") {
			FMs=max(FMs,5);
			cmbFM_5->setCurrentItem(x);
		}
		else if (n.left(3)=="FM6") {
			FMs=max(FMs,6);
			cmbFM_6->setCurrentItem(x);
		}
		else if (n.left(4)=="PSG1") {
			PSGs=max(PSGs,1);
			cmbPSG_1->setCurrentItem(x);
		}
		else if (n.left(4)=="PSG2") {
			PSGs=max(PSGs,2);
			cmbPSG_2->setCurrentItem(x);
		}
		else if (n.left(4)=="PSG3") {
			PSGs=max(PSGs,3);
			cmbPSG_3->setCurrentItem(x);
		}
		else if (n.left(3)=="DAC") {
			DAC=1;
			cmbDAC->setCurrentItem(x);
		}
		else if ((n.left(4)=="HATS") || (n.left(5)=="NOISE")) {
			NoiseChannel = x;
		
		}
	}
	if (NoiseChannel!=-1) {
		chkPSGNoise->setChecked(true);
		switch(PSGs) {
		case 0:
			cmbPSG_1->setCurrentItem(NoiseChannel);
			break;
		case 1:
			cmbPSG_2->setCurrentItem(NoiseChannel);
			break;
		case 2:
			cmbPSG_3->setCurrentItem(NoiseChannel);
			break;
		default:
			QMessageBox::critical(this,
					      "Error", 
					      "Both PSG Noise and PSG3 are defined.");
			return;
		}
		PSGs++;
	}
	else 
		chkPSGNoise->setChecked(false);
				
	if (DAC) {
		chkDAC->setChecked(true);
		if (FMs == 6) {
			QMessageBox::critical(this,
					    "Error", 
					    "Both DAC and FM6 are defined.");
			return;
		}
	}
	else 
		chkDAC->setChecked(false);
	
	
	sliderFMs->setValue(FMs);
	sliderPSGs->setValue(PSGs);
	
	// Simulate these events so that the interface gets updated properly
	chkDAC_clicked();
	sliderFMs_sliderMoved(FMs);
	sliderPSGs_sliderMoved(PSGs);
	chkPSGNoise_clicked();
}	
	

void frmMain::chkPanningFM1_clicked()
{
	panFM1->setEnabled(!(chkPanningFM1->isChecked()));
}
void frmMain::chkPanningFM2_clicked()
{
	panFM2->setEnabled(!(chkPanningFM2->isChecked()));
}
void frmMain::chkPanningFM3_clicked()
{
	panFM3->setEnabled(!(chkPanningFM3->isChecked()));
}
void frmMain::chkPanningFM4_clicked()
{
	panFM4->setEnabled(!(chkPanningFM4->isChecked()));
}
void frmMain::chkPanningFM5_clicked()
{
	panFM5->setEnabled(!(chkPanningFM5->isChecked()));
}
void frmMain::chkPanningFM6_clicked()
{
	panFM6->setEnabled(!(chkPanningFM6->isChecked()));
}
void frmMain::chkPanningDAC_clicked()
{
	panDAC->setEnabled(!(chkPanningDAC->isChecked()));
}

void frmMain::lstVoicesFile_highlighted( QListBoxItem * )
{
	QString str="";
	uchar selection=lstVoicesFile->currentItem();
	for (uchar i=0; i<0x19; ++i) {
		str+=itoa(rawvoices_file[selection*0x19+i],16) + ' ';
	}
	lblVoice_File->setText(str);
}


void frmMain::cmdAddVoice_clicked()
{
  	if (lstVoicesFile->currentItem()==-1) return;    
	uchar currentvsize = voices.size();
	voices.resize(currentvsize+0x19,0);
	for (uchar i=0; i<0x19; ++i)
		voices[i+currentvsize]=rawvoices_file[lstVoicesFile->currentItem()*0x19+i];
	lstVoicesSong->insertItem(lstVoicesFile->selectedItem()->text());
	
}



void frmMain::lstVoicesSong_highlighted( int selection )
{
	QString str="";
	for (uchar i=0; i<0x19; ++i) {
		str+=itoa(voices[selection*0x19+i],16) + ' ';
	}
	lblVoice_Song->setText(str);
}


void frmMain::cmdPasteVoice_clicked()
{
	bool ok;
	QString voicestr = QInputDialog::getText("XM4SMPS","Enter a voice:", QLineEdit::Normal, QString::null, &ok, this);
	if (ok && !voicestr.isEmpty()) {
	    
		uchar voice[0x19];
		QString strippedstring="";
		for (uchar i=0; i<(uchar)voicestr.length(); ++i)
		    if (isalnum(voicestr[i].latin1()))
			strippedstring+=voicestr[i];

		for (uchar i=0; i<0x19; ++i) {
			QString this_byte = strippedstring.mid(i*2,2);
			voice[i] = this_byte.toInt(&ok,16);
			if (!ok) {
				QMessageBox::critical(this,"Error", "You're doing it wrong! (aka: that's not a hex voice)");
				return;
			}
		}
		uchar currentvsize = voices.size();
		voices.resize(currentvsize+0x19,0);
		for (uchar i=0; i<0x19; ++i)
			voices[i+currentvsize]=voice[i];
		lstVoicesSong->insertItem("Pasted voice");
		
	}
}


void frmMain::lstVoicesSong_doubleClicked( QListBoxItem * )
{
	bool ok;
	uchar selection=lstVoicesSong->currentItem();
	QString voicename = QInputDialog::getText("XM4SMPS","Enter the name for the voice:", QLineEdit::Normal, lstVoicesSong->selectedItem()->text(),&ok,this);
	if (!ok) return;
	lstVoicesSong->changeItem(voicename,selection);
	
}


void frmMain::lstVoicesFile_doubleClicked( QListBoxItem * )
{
	cmdAddVoice_clicked();
}


void frmMain::cmdSaveVoiceBank_clicked()
{
	
	QFileDialog sfn	(this, "Select where you want to save the voice bank");
	sfn.setMode(QFileDialog::AnyFile);
	sfn.setViewMode(QFileDialog::Detail);
/*	sfn.setFilter("xm3smps voice files (*.x3v)");
	sfn.addFilter("Sonic QX voice files (*.ymx)");
	sfn.addFilter("Raw SMPS voices (*.bin)");	 */
	QStringList types;
	types	<< "xm3smps voice files (*.x3v)"
	 	<< "Raw SMPS voices (*.bin)"
		<< "Sonic QX voice files (*.ymx)";
	sfn.setFilters(types);
	
#if QT_VERSION >= 0x40000	// For QT4 compatibility and shit
	sfn.selectFilter("xm4smps voice files (*.x3v)");
#else
	sfn.setSelectedFilter("xm4smps voice files (*.x3v)"); // Set default filter to x3v 
#endif
	
	QString filename,filter;
	if (sfn.exec() == QDialog::Accepted)
		filename = sfn.selectedFile();
	else	
		return;
	filter = sfn.selectedFilter();
	uchar *outfile;
	uint filesize;
	if (filter == "Raw SMPS voices (*.bin)") {
		// raw smps output "filter" (if you can call it that)
		outfile = vector2array(voices);
		filesize = voices.size();
	}
	else if (filter == "xm3smps voice files (*.x3v)") {
		// x3v output filter
		uchar numvoices = lstVoicesSong->numRows();
		filesize = 0x19*numvoices + 1;
		for (uchar i=0; i<numvoices; ++i) {
			QString voicename = lstVoicesSong->item(i)->text();
			filesize += voicename.length()+1;
		}
		outfile = new uchar[filesize];
		outfile[0]=numvoices;
		uint pc=1;
		for (uchar i=0; i<numvoices; ++i) {
			for (uchar j=0; j<0x19; ++j)
				outfile[pc++]=voices.at(i*0x19+j);
			QString voicename = lstVoicesSong->item(i)->text();
			uchar voicelength = voicename.length();
			outfile[pc++] = voicelength;
			for (uchar j=0; j<voicelength; ++j)
				outfile[pc++] = voicename.at(j).latin1();
		}
			
			
			
	}
	else if (filter == "Sonic QX voice files (*.ymx)") {
		uchar numvoices = lstVoicesSong->numRows();
		filesize = 8 + 35*numvoices;
		outfile = new uchar[filesize];
		outfile[0] = 'Y';
		outfile[1] = 'M';
		outfile[2] = '2';
		outfile[3] = '6';
		outfile[4] = '1';
		outfile[5] = '2';
		outfile[6] = 0;
		outfile[7] = ((char)numvoices)-1;
		uint pc=8;
		for (uchar i=0; i<numvoices; ++i) {
			// This is already mentioned twice in the source, but I'll repeat myself for emphasis
			// I HATE BYTESWAPPING
			outfile[pc++] = voices.at(i*0x19+0);
			outfile[pc++] = voices.at(i*0x19+1);
			outfile[pc++] = voices.at(i*0x19+3);
			outfile[pc++] = voices.at(i*0x19+2);
			outfile[pc++] = voices.at(i*0x19+4);
			outfile[pc++] = voices.at(i*0x19+5);
			outfile[pc++] = voices.at(i*0x19+7);
			outfile[pc++] = voices.at(i*0x19+6);
			outfile[pc++] = voices.at(i*0x19+8);
			outfile[pc++] = voices.at(i*0x19+9);
			outfile[pc++] = voices.at(i*0x19+0xB);
			outfile[pc++] = voices.at(i*0x19+0xA);
			outfile[pc++] = voices.at(i*0x19+0xC);
			outfile[pc++] = voices.at(i*0x19+0xD);
			outfile[pc++] = voices.at(i*0x19+0xF);
			outfile[pc++] = voices.at(i*0x19+0xE);
			outfile[pc++] = voices.at(i*0x19+0x10);
			outfile[pc++] = voices.at(i*0x19+0x11);
			outfile[pc++] = voices.at(i*0x19+0x13);
			outfile[pc++] = voices.at(i*0x19+0x12);
			outfile[pc++] = voices.at(i*0x19+0x14);
			outfile[pc++] = voices.at(i*0x19+0x15);
			outfile[pc++] = voices.at(i*0x19+0x17);
			outfile[pc++] = voices.at(i*0x19+0x16);
			outfile[pc++] = voices.at(i*0x19+0x18);
			
			// Now for the damn string
			
			QString voicename = lstVoicesSong->item(i)->text();
			while (voicename.length()<10)
				voicename+=' '; // Pad it with spaces;
			voicename.truncate(10); // If it's bigger, cut it off
			for (uchar j=0; j<10; ++j)
				outfile[pc++]=voicename.at(j).latin1();
		}
			
			
			
	}
	else return;
	
	QFile file(filename);
	file.open(IO_WriteOnly);
	QDataStream stream(&file);
	stream.writeRawBytes((char*)outfile,filesize);
	file.close();

}



void frmMain::cmdDelVoice_clicked()
{
	if (lstVoicesSong->currentItem()==-1) return;    
	uchar selection=lstVoicesSong->currentItem();	
	uint vsize = voices.size();
	for (uint i=selection*0x19; i<vsize-0x19; ++i)
		voices[i]=voices[i+0x19];
	voices.resize(vsize-0x19);
	delete lstVoicesSong->selectedItem();
}





void frmMain::lstFMInstr_highlighted( int item )
{
	lstFMVoice->setSelected(fmvoices.at(item),true);
}



void frmMain::lstFMVoice_highlighted( int voiceno )
{
	fmvoices.at(lstFMInstr->currentItem())=voiceno;
}


void frmMain::lstPSGInstr_highlighted( int item )
{
	lstPSGVoice->setSelected(psgvoices.at(item),true);

}


void frmMain::lstPSGVoice_highlighted( int voiceno )
{
	psgvoices.at(lstPSGInstr->currentItem())=voiceno;

}





void frmMain::chkNoteNums_toggled( bool checked )
{
	lstDACInstr->clear();
	if (checked)
		for (uchar i=1; i<9; ++i) {
			lstDACInstr->insertItem(QString("C-") + itoa(i));
			lstDACInstr->insertItem(QString("C#") + itoa(i));
			lstDACInstr->insertItem(QString("D-") + itoa(i));
			lstDACInstr->insertItem(QString("D#") + itoa(i));
			lstDACInstr->insertItem(QString("E-") + itoa(i));
			lstDACInstr->insertItem(QString("F-") + itoa(i));
			lstDACInstr->insertItem(QString("F#") + itoa(i));
			lstDACInstr->insertItem(QString("G-") + itoa(i));
			lstDACInstr->insertItem(QString("G#") + itoa(i));
			lstDACInstr->insertItem(QString("A-") + itoa(i));
			lstDACInstr->insertItem(QString("A#") + itoa(i));
			lstDACInstr->insertItem(QString("B-") + itoa(i));
			
		}
	else 
		for (ushort i=0x1; i<0x100; ++i)
			lstDACInstr->insertItem(itoa(i));
	
	
}


void frmMain::chkPSGNoteNums_toggled( bool checked )
{
	lstNoiseInstr->clear();
	if (checked)
		for (uchar i=1; i<9; ++i) {
			lstNoiseInstr->insertItem(QString("C-") + itoa(i));
			lstNoiseInstr->insertItem(QString("C#") + itoa(i));
			lstNoiseInstr->insertItem(QString("D-") + itoa(i));
			lstNoiseInstr->insertItem(QString("D#") + itoa(i));
			lstNoiseInstr->insertItem(QString("E-") + itoa(i));
			lstNoiseInstr->insertItem(QString("F-") + itoa(i));
			lstNoiseInstr->insertItem(QString("F#") + itoa(i));
			lstNoiseInstr->insertItem(QString("G-") + itoa(i));
			lstNoiseInstr->insertItem(QString("G#") + itoa(i));
			lstNoiseInstr->insertItem(QString("A-") + itoa(i));
			lstNoiseInstr->insertItem(QString("A#") + itoa(i));
			lstNoiseInstr->insertItem(QString("B-") + itoa(i));
		}
	else 
		for (ushort i=0x1; i<0x100; ++i)
			lstNoiseInstr->insertItem(itoa(i));

}


void frmMain::lstDACInstr_highlighted( int item )
{
	lstDACSamples->setSelected(dacsamples.at(item),true);
}


void frmMain::lstDACSamples_highlighted( int sampleno )
{	
	dacsamples.at(lstDACInstr->currentItem())=sampleno;
}


void frmMain::lstNoiseInstr_highlighted( int item )
{
	radClosedHat->setChecked(!noisevoices.at(item));
	radOpenHat->setChecked(noisevoices.at(item));
	
}


void frmMain::cmdConvert_clicked()
{
	
    
	// Unpack an XM
	uint pc = 0x150;
	if (!xm) {
	    QMessageBox::critical(this,"Nigga you gay","Load an XM first...");
	    return;
	}/*}
  Pasted here to help me remember where some shit is
	lblLoop->setText(itoa(xm[66]));
	lblChannels->setText(itoa(xm[68]));
	lblPatterns->setText(itoa((xm[70] ? xm[70] : 256)));
*/
	
	// xmdata.at(x).at(y).at(z) - byte z of channel y, pattern x
	
	ushort numpatterns = xm[70] ? xm[70] : 0x100;
	xmdata.resize(numpatterns);
	for (ushort i=0; i<numpatterns; ++i) {
		uint nrows;
		xmdata.at(i).resize(xm[68]);
		uchar current_channel = 0;
		pc +=5; // Skip the "pattern header size, which is always 9, and is stored in a dword of all things... Packing type is always zero, so skip that too
		nrows = xm[pc] ? xm[pc] : 0x100;
		for (ushort j=0; j<xm[68]; ++j)
			xmdata.at(i).at(j).resize(nrows*5); // Each row takes 5 bytes
		pc+=2; // 7th byte of pattern header, i.e. pattern size
		ushort patternsize = xm[pc] + (xm[pc+1]<<8);
		pc+=2;
		uint startpc = pc;
		uint channelpc=0;
		while (pc < (startpc+patternsize)) {
			uchar note = xm[pc++];
			if (note&0x80) { // Packing
				if (note&1)
					xmdata.at(i).at(current_channel).at(channelpc) = xm[pc++];
				else
					xmdata.at(i).at(current_channel).at(channelpc) = 0;
				
				if (note&2)
					xmdata.at(i).at(current_channel).at(channelpc+1) = xm[pc++];
				else
					xmdata.at(i).at(current_channel).at(channelpc+1) = 0;
				
				if (note&4)
					xmdata.at(i).at(current_channel).at(channelpc+2) = xm[pc++];
				else
					xmdata.at(i).at(current_channel).at(channelpc+2) = 0;
				
				if (note&8)
					xmdata.at(i).at(current_channel).at(channelpc+3) = xm[pc++];
				else
					xmdata.at(i).at(current_channel).at(channelpc+3) = 0;
				
				if (note&16)
					xmdata.at(i).at(current_channel).at(channelpc+4) = xm[pc++];
				else
					xmdata.at(i).at(current_channel).at(channelpc+4) = 0;		
				
			}
			else {
				xmdata.at(i).at(current_channel).at(channelpc) = note;
				xmdata.at(i).at(current_channel).at(channelpc+1) = xm[pc++];
				xmdata.at(i).at(current_channel).at(channelpc+2) = xm[pc++];
				xmdata.at(i).at(current_channel).at(channelpc+3) = xm[pc++];
				xmdata.at(i).at(current_channel).at(channelpc+4) = xm[pc++];			
			}
			current_channel++;
			if (current_channel >= xm[68]) {
				current_channel=0;
				channelpc+=5;
			}
		}
	}
		
	// Lots and lots of variables
	QString basefilestr;
	basefilestr = txtFilename->text();
	basefilestr = basefilestr.right(basefilestr.length()-basefilestr.findRev("/")-1);
	basefilestr = basefilestr.left(basefilestr.length()-3);
	QString basefilename="";
	for (uchar i=0; i<(uchar)basefilestr.length(); ++i)
	    if (isalpha(basefilestr[i].latin1()))
		basefilename+=basefilestr[i];
	QString filenamenoext = txtFilename->text();
	filenamenoext = filenamenoext.left(filenamenoext.length()-3); // Strip '.xm'.
	uchar numfms = sliderFMs->value();
	uchar numpsgs = sliderPSGs->value();
	bool havedac = chkDAC->isChecked();
	QValueVector<uchar> fmvols,psgvols,fmpitches,psgpitches,fmchannelids,psgchannelids,fmpans;
	QValueVector<bool> fmxmpan;
	uchar dacchannelid, dacpan;
	bool dacxmpan;
	fmvols.resize(6);
	fmpitches.resize(6);
	fmchannelids.resize(6);
	fmpans.resize(6);
	fmxmpan.resize(6);
	psgvols.resize(3);
	psgpitches.resize(3);
	psgchannelids.resize(3);
	dacchannelid=cmbDAC->currentItem();
	
	
	fmpans.at(5) = panFM6->value();
	fmpans.at(4) = panFM5->value();
	fmpans.at(3) = panFM4->value();
	fmpans.at(2) = panFM3->value();
	fmpans.at(1) = panFM2->value();
	fmpans.at(0) = panFM1->value();
	dacpan = panDAC->value();
	dacxmpan = chkPanningDAC->isChecked();

	fmxmpan.at(5) = chkPanningFM6->isChecked();
	fmxmpan.at(4) = chkPanningFM5->isChecked();
	fmxmpan.at(3) = chkPanningFM4->isChecked();
	fmxmpan.at(2) = chkPanningFM3->isChecked();
	fmxmpan.at(1) = chkPanningFM2->isChecked();
	fmxmpan.at(0) = chkPanningFM1->isChecked();
	
	fmchannelids.at(5) = cmbFM_6->currentItem();
	fmchannelids.at(4) = cmbFM_5->currentItem();
	fmchannelids.at(3) = cmbFM_4->currentItem();
	fmchannelids.at(2) = cmbFM_3->currentItem();
	fmchannelids.at(1) = cmbFM_2->currentItem();
	fmchannelids.at(0) = cmbFM_1->currentItem();
	
	psgchannelids.at(2) = cmbPSG_3->currentItem();
	psgchannelids.at(1) = cmbPSG_2->currentItem();
	psgchannelids.at(0) = cmbPSG_1->currentItem();
	
	
	psgvols.at(2) = spinVolumePSG3->value();
	psgvols.at(1) = spinVolumePSG2->value();
	psgvols.at(0) = spinVolumePSG1->value();
	
	psgpitches.at(2) = spinPitchPSG3->value();
	psgpitches.at(1) = spinPitchPSG2->value();
	psgpitches.at(0) = spinPitchPSG1->value();
	
	fmvols.at(5) = spinVolumeFM6->value();
	fmvols.at(4) = spinVolumeFM5->value();
	fmvols.at(3) = spinVolumeFM4->value();
	fmvols.at(2) = spinVolumeFM3->value();
	fmvols.at(1) = spinVolumeFM2->value();
	fmvols.at(0) = spinVolumeFM1->value();
	
	fmpitches.at(5) = spinPitchFM6->value();
	fmpitches.at(4) = spinPitchFM5->value();
	fmpitches.at(3) = spinPitchFM4->value();
	fmpitches.at(2) = spinPitchFM3->value();
	fmpitches.at(1) = spinPitchFM2->value();
	fmpitches.at(0) = spinPitchFM1->value();
	
	// End of that
	
	// Now some checks to see if the user is not an idiot
	
	for (ushort i=0; i<numfms; ++i) {
	    if (fmchannelids.at(i)>=xm[68]) {
		QMessageBox::critical(this,"Uhh...","I'm pretty sure you're supposed to select FM" + itoa(i+1) + "'s XM channel first...");
		return;
	    }
	}
	
	for (ushort i=0; i<numpsgs; ++i) {
	    if (psgchannelids.at(i)>=xm[68]) {
		QMessageBox::critical(this,"Uhh...","I'm pretty sure you're supposed to select PSG" + itoa(i+1) + "'s XM channel first...");
		return;
	    }
	}
	
	if (havedac && dacchannelid>=xm[68])
	    QMessageBox::critical(this,"Uhh...","I'm pretty sure you're supposed to select DAC's XM channel first...");
	
	// First pass - not much happens in here, and nothing is written to the file, but it can help optimising
	// xmdata.at(x).at(y).at(z) - byte z of channel y, pattern x
	// xmvoices.at(x).at(y) - channel y's last voice on pattern x
	QValueVector<QValueVector<uchar> > xmvoices;
	QValueVector<QValueVector<uchar> > xmpanning;

	xmvoices.resize(0);
	xmvoices.resize(numpatterns);
	for (ushort i=0; i<numpatterns; ++i)
	    xmvoices.at(i).resize(xm[68],0xFD);
	
	for (ushort i=0; i<numfms; ++i) {
	    ushort xmchannel = fmchannelids.at(i);
	    for (ushort j=0; j<numpatterns; ++j) { 
		ushort currentinst=0;		
		for (ushort x=0; x<(ushort)(xmdata.at(j).at(xmchannel).size()); x+=5) {
		    if (xmdata.at(j).at(xmchannel).at(x+1))
			currentinst=xmdata.at(j).at(xmchannel).at(x+1);
		}
		if (currentinst) {
		    xmvoices.at(j).at(xmchannel) = fmvoices.at(currentinst-1);
		}
	    }
	}
	for (ushort i=0; i<numpsgs; ++i) {
	    ushort xmchannel = psgchannelids.at(i);
	    for (ushort j=0; j<numpatterns; ++j) { 
		ushort currentinst=0;		
		for (ushort x=0; x<(ushort)(xmdata.at(j).at(xmchannel).size()); x+=5) {
		    if (xmdata.at(j).at(xmchannel).at(x+1))
			currentinst=xmdata.at(j).at(xmchannel).at(x+1);		    
		}

		if (currentinst) {
		    xmvoices.at(j).at(xmchannel) = psgvoices.at(currentinst-1);
		}
	    }
	}
	
	/*for (ushort i=0; i<xm[64]-1; ++i) {
	    for (ushort j=0; j<numfms; ++j) {
		ushort xmch = fmchannelids.at(j);
		msgboxd((QString)"Last voice for channel " + itoa(xmch) + " in pattern " + itoa(i) + " is " + 
			itoa(xmvoices.at(i).at(xmch)));
	    }
	}*/
	
	QValueVector<QValueVector<uchar> > prevvoices;
	prevvoices.resize(0);
	prevvoices.resize(numpatterns);
	for (ushort i=0; i<numpatterns; ++i)
	    prevvoices.at(i).resize(xm[68],0xFF);
	for (ushort i=0; i<numfms; ++i) {
	    ushort xmchannel=fmchannelids.at(i);
	    for (ushort j=0; j<xm[64]-1; ++j) {
		if (prevvoices.at(xm[j+81]).at(xmchannel)==0xFF)
		    prevvoices.at(xm[j+81]).at(xmchannel)=xmvoices.at(xm[j+80]).at(xmchannel);
		else
		    if (prevvoices.at(xm[j+81]).at(xmchannel)!=xmvoices.at(xm[j+80]).at(xmchannel))
			prevvoices.at(xm[j+81]).at(xmchannel)=0xFE;
	    }
		
	}
	for (ushort i=0; i<numpsgs; ++i) {
	    ushort xmchannel=psgchannelids.at(i);
	    for (ushort j=0; j<xm[64]-1; ++j) {
		if (prevvoices.at(xm[j+81]).at(xmchannel)==0xFF)
		    prevvoices.at(xm[j+81]).at(xmchannel)=xmvoices.at(xm[j+80]).at(xmchannel);
		else
		    if (prevvoices.at(xm[j+81]).at(xmchannel)!=xmvoices.at(xm[j+80]).at(xmchannel))
			prevvoices.at(xm[j+81]).at(xmchannel)=0xFE;
	    }
		
	} 

	// debug
	

	for (ushort i=0; i<xm[68]; ++i) {
	    prevvoices.at(xm[80]).at(i) = 0xFF; // First one ALWAYS needs the EF there so yeah	    
	}
	//msgboxd(itoa(xm[79+xm[64]]));
	if (xm[66]) {
	    for (ushort i=0; i<xm[68]; ++i) {
		if (prevvoices.at(xm[80+xm[66]]).at(i)!=xmvoices.at(xm[79+xm[64]]).at(i))
		    prevvoices.at(xm[80+xm[66]]).at(i) = 0xFF; // Loop pattern should check with last pattern
	    }
	}
	/*
	for (ushort i=0; i<xm[64]-1; ++i) {
	    for (ushort j=0; j<numfms; ++j) {
		ushort xmch = fmchannelids.at(j);
		msgboxd((QString)"Previous voice for channel " + itoa(xmch) + " in pattern " + itoa(i) + " is " + 
			itoa(prevvoices.at(i).at(xmch)));
	    }
	}*/

	QValueVector<QValueVector<uchar> > eqpattern;
	eqpattern.resize(xm[68]);
	for (ushort c=0; c<xm[68]; ++c) {
	    eqpattern.at(c).resize(numpatterns);
	    for (ushort p=0; p<numpatterns; ++p)
		eqpattern.at(c).at(p)=p;
	}
	
	for (ushort c=0; c<xm[68]; ++c) {
	    for (ushort p1=0; p1<numpatterns; ++p1) {
		for (ushort p2=0; p2<numpatterns; ++p2) {
		    if ((p1!=p2) && compare_patterns(c,p1,p2)) {
			eqpattern.at(c).at(p2) = min(eqpattern.at(c).at(p2),p1);
			
			if (prevvoices.at(p1).at(c)!=(prevvoices.at(p2).at(c)))
			    prevvoices.at(p1).at(c)=0xFF;
			
			
		    }
			
		}
	    }
	}
	
	// After that, we need to convert this to SMPS... more on the 10 o' clock news!
	// Stay tuned
	
	QFile smpsf(filenamenoext + ".asm");
	smpsf.open(IO_WriteOnly);
	QTextStream smps(&smpsf);
	
	smps << "; -------------------------------------------------------" << endl;
	smps << "; File created using XM4SMPS v" X4SVERSION " (Qt " QT_VERSION_STR OpSys ")" << endl;
	smps << "; Created on " << (QDate::currentDate().toString() + ", " + QTime::currentTime().toString()) << endl;
	smps << "; -------------------------------------------------------" << endl;
	smps << endl;
	smps << basefilename << "_Header:" << endl;
	smps << "\tsmpsHeaderVoice\t" << basefilename << "_Voices" << endl;
	smps << "\tsmpsHeaderChan\t" << hex << (int)(numfms+1) << ',' << numpsgs << endl;
	smps << "\tsmpsHeaderTempo\t$" << (lstTempo1->currentItem()+1) << ", $" << (lstTempo2->currentItem()+2) << endl;
	if (havedac)
		smps << "\tsmpsHeaderDAC\t" << basefilename << "_DAC" << endl;
	else
		smps << "\tdc.l $000900F2\t; This song has no DAC" << endl;
	
	for (uchar i=1; i<=numfms; ++i)
		smps << "\tsmpsHeaderFM\t" << basefilename << "_FM" << (int)i << ",\t$" << fmpitches.at(i-1) << ", $" << fmvols.at(i-1) << endl;
	
	for (uchar i=1; i<=numpsgs; ++i)
		smps << "\tsmpsHeaderPSG\t" << basefilename << "_PSG" << (int)i << ",\t$" << psgpitches.at(i-1) << ", $" << psgvols.at(i-1) << ", $0" << endl;
	smps << endl;
	// Now we do each channel
	
	for (uchar i=1; i<=numfms; ++i) {
	    ushort xmchannel=fmchannelids.at(i-1); 
	    smps << basefilename << "_FM" << (int)i << ':' << endl;
	    if ((fmpans.at(i-1)!=1) && !fmxmpan.at(i-1)) // There's no need to insert panning if it's center
		smps << "\tsmpsPan\t\t" << (fmpans.at(i-1) ? "panRight" : "panLeft") << ",0" << endl;
	    for (uchar p=0; p<xm[64]; ++p) {
		if ((p==xm[66]) && p) smps << basefilename << "_FM" << (int)i << "_Loop:" << endl;	
		smps << "\tsmpsCall\t" << basefilename << "_FM" << (int)i << "_p" << (int)(eqpattern.at(xmchannel).at(xm[80+p])) << endl;
	    }
	    if (chkLoop->isChecked())
		smps << "\tsmpsJump\t" << basefilename << "_FM" << (int)i << (xm[66] ? "_Loop" : "") << endl;
	    else
		smps << "\tsmpsStop" << endl;
	    smps << endl;
	}
	
	for (uchar i=1; i<=numpsgs; ++i) {
		short xmchannel=psgchannelids.at(i-1);
		smps << basefilename << "_PSG" << (int)i << ':' << endl;
		if (chkPSGNoise->isChecked() && i==numpsgs) // Put an F3 E7 in the noise channel
			smps << "\tsmpsPSGform\t$E7" << endl;			
		
		for (uchar p=0; p<xm[64]; ++p) {
			if ((p==xm[66]) && p) smps << basefilename << "_PSG" << (int)i << "_Loop:" << endl;	
			smps << "\tsmpsCall\t" << basefilename << "_PSG" << (int)i << "_p" << (int)(eqpattern.at(xmchannel).at(xm[80+p])) << endl;
		}
		if (chkLoop->isChecked())
			smps << "\tsmpsJump\t" << basefilename << "_PSG" << (int)i << (xm[66] ? "_Loop" : "") << endl;
		else
			smps << "\tsmpsStop" << endl;
		smps << endl;
	}
	
	if (havedac) {
		short xmchannel=dacchannelid;
		smps << basefilename << "_DAC:" << endl;
		if ((dacpan!=1) && !dacxmpan)
			smps << "\tsmpsPan\t\t" << (dacpan ? "panRight" : "panLeft") << ",0" << endl;
		
		for (uchar p=0; p<xm[64]; ++p) {
			if ((p==xm[66]) && p) smps << basefilename << "_DAC_Loop:" << endl;	
			smps << "\tsmpsCall\t" << basefilename << "_DAC_p" << (int)(eqpattern.at(xmchannel).at(xm[80+p])) << endl;
		}
		if (chkLoop->isChecked())
			smps << "\tsmpsJump\t" << basefilename << "_DAC" << (xm[66] ? "_Loop" : "") << endl;
		else
			smps << "\tsmpsStop" << endl;
		smps << endl;
	}
 
	// Let's start converting the FM channels!
	// Reference: xmdata.at(pattern).at(channel).at(byte)
	for (ushort i=0; i<numfms; ++i) {
	    
		ushort xmchannel = fmchannelids.at(i);
		QValueVector<bool> didpatternx;
		didpatternx.resize(numpatterns);
		smps << endl << "; Pattern data for FM" << (i+1);
		for (ushort z=0; z<xm[64]; ++z) {
		    
			ushort j=eqpattern.at(xmchannel).at(xm[80+z]);
			if (didpatternx.at(j)) continue;
			didpatternx.at(j)=true;
			smps << endl << basefilename << "_FM" << (i+1) << "_p" << j << ':' << endl;
			ushort previousnote=0;
			ushort previousdur=0;
			ushort dur=0;
			ushort note=0x67;
			ushort currentvoice=prevvoices.at(j).at(xmchannel); // Previous voice 
			ushort panning = 4;
			ushort lastopt = 0;
			for (ushort x=0; x<(ushort)(xmdata.at(j).at(xmchannel).size()); x+=5) {
				if (!(xmdata.at(j).at(xmchannel).at(x))) dur++;
				else {
					if (dur) {

						if (dur==previousdur) {
							lastopt=1;
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;							}
						else if (note==previousnote  && lastopt!=1) { 
							// If the last time we inserted just the note
							// then we can't insert just a duration or we'll lose one note
							lastopt=2;
							smps << "\tdc.b\t\t$";
							while (dur>0x7F) {
								smps << "7F,smpsNoAttack,$";
								dur-=0x7F;
							}
										
							smps << dur << endl;
						}
						else	{
							lastopt=0;
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";
							while (dur>0x7F) {
								smps << "7F,smpsNoAttack,$";
								dur-=0x7F;
							}
							smps << dur << endl;
						}
						
					}
					ushort instr = xmdata.at(j).at(xmchannel).at(x+1);
					ushort volume = xmdata.at(j).at(xmchannel).at(x+2);
					ushort effect = xmdata.at(j).at(xmchannel).at(x+3);
					ushort efedat = xmdata.at(j).at(xmchannel).at(x+4);
					ushort voice = fmvoices.at(instr-1);
					
					if ((voice!=currentvoice) && instr) {
						smps << "\tsmpsFMvoice\t$" << voice << endl;
						currentvoice=voice;
					}
					if (fmxmpan.at(i) && ((effect == 8) || (effect == 0) || ((volume&0xF0)==0xC0))) {
						ushort outpan=1;
						if (effect&(efedat<0x7F)) outpan = 0;
						if (effect&(efedat>0x80)) outpan = 2;
						if (volume>0xC8) outpan = 2;
						if ((volume>=0xC0)&&(volume<0xC7)) outpan = 0;
						if (outpan!=panning) {
							panning=outpan;
							switch(panning) {
							case 0:
								smps << "\tsmpsPan\t\tpanLeft,0" << endl;
								break;
							case 1:
								smps << "\tsmpsPan\t\tpanCentre,0" << endl; // Hi Marc
								break;
							case 2:
								smps << "\tsmpsPan\t\tpanRight,0" << endl;
								break;
							}
						}
							
					}
					if (((effect == 3) && (efedat == 0xFF)) || (volume == 0xFF))	
						smps << "\tdc.b\t\tsmpsNoAttack ; max-speed portamento" << endl;
					previousdur=dur;
					previousnote=note;
					dur=1;
					note = xmdata.at(j).at(xmchannel).at(x);
				}
					
			}
			
			
			if (dur==previousdur)
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;
			else if (note==previousnote && lastopt!=1) {
				smps << "\tdc.b\t\t$";
				while (dur>0x7F) {
					smps << "7F,smpsNoAttack,$";
					dur-=0x7F;
				}
				
				smps << dur << endl;
			}
			else	{
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";
				while (dur>0x7F) {
					smps << "7F,smpsNoAttack,$";
					dur-=0x7F;
				}
				smps << dur << endl;
			}

			smps << "\tsmpsReturn" << endl;
		}
	}
	// Let's start converting the PSG channels!
	// Reference: xmdata.at(pattern).at(channel).at(byte)
	ushort numpsgtones = numpsgs;
	if (chkPSGNoise->isChecked() && numpsgs) // To prevent accidentally setting numpsgtones to -1 :x
		numpsgtones--;
	
	for (ushort i=0; i<numpsgtones; ++i) {
		ushort xmchannel = psgchannelids.at(i);
		smps << endl << "; Pattern data for PSG" << (i+1);		
		QValueVector<bool> didpatternx;
		didpatternx.resize(numpatterns);
		for (ushort z=0; z<xm[64]; ++z) {
		    
			ushort j=eqpattern.at(xmchannel).at(xm[80+z]);
			if (didpatternx.at(j)) continue;
			didpatternx.at(j)=true;
		    
			smps << endl << basefilename << "_PSG" << (i+1) << "_p" << j << ':' << endl;
			ushort previousnote=0;
			ushort previousdur=0;
			ushort dur=0;
			ushort note=0x67;
			ushort currentvoice=prevvoices.at(j).at(xmchannel); // Previous voice 
			ushort lastopt = 0;
			for (ushort x=0; x<(ushort)(xmdata.at(j).at(xmchannel).size()); x+=5) {
				if (!(xmdata.at(j).at(xmchannel).at(x))) dur++;
				else {
					if (dur) {

						if (dur==previousdur) {
							lastopt=1;
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;							}
						else if (note==previousnote && lastopt!=1) {
							lastopt=2;
							smps << "\tdc.b\t\t$";
							while (dur>0x7F) {
								smps << "7F,smpsNoAttack,$";
								dur-=0x7F;
							}
										
							smps << dur << endl;
						}
						else	{
							lastopt=0;
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";
							while (dur>0x7F) {
								smps << "7F,smpsNoAttack,$";
								dur-=0x7F;
							}
							smps << dur << endl;
						}
						
					}
					ushort instr = xmdata.at(j).at(xmchannel).at(x+1);
					ushort volume = xmdata.at(j).at(xmchannel).at(x+2);
					ushort effect = xmdata.at(j).at(xmchannel).at(x+3);
					ushort efedat = xmdata.at(j).at(xmchannel).at(x+4);
					ushort voice = psgvoices.at(instr-1);
					
					if ((voice!=currentvoice) && instr) {
						smps << "\tsmpsPSGvoice\t$" << voice << endl;
						currentvoice=voice;
					}
					
					if (((effect == 3) && (efedat == 0xFF)) || (volume == 0xFF))	
						smps << "\tdc.b\t\tsmpsNoAttack ; max-speed portamento" << endl;
					previousdur=dur;
					previousnote=note;
					dur=1;
					note = xmdata.at(j).at(xmchannel).at(x);
				}
					
			}
			
			
			if (dur==previousdur)
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;
			else if (note==previousnote && lastopt!=1) {
				smps << "\tdc.b\t\t$";
				while (dur>0x7F) {
					smps << "7F,smpsNoAttack,$";
					dur-=0x7F;
				}
				
				smps << dur << endl;
			}
			else	{
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";
				while (dur>0x7F) {
					smps << "7F,smpsNoAttack,$";
					dur-=0x7F;
				}
				smps << dur << endl;
			}

			smps << "\tsmpsReturn" << endl;
		}
	}
	
	// PSG Noise
	if (chkPSGNoise->isChecked() && numpsgs) {
		ushort i=numpsgs-1;
		ushort xmchannel = psgchannelids.at(i);
		smps << endl << "; Pattern data for PSG" << (i+1) << " (Noise)";		
		QValueVector<bool> didpatternx;
		didpatternx.resize(numpatterns);
		for (ushort z=0; z<xm[64]; ++z) {
		    
			ushort j=eqpattern.at(xmchannel).at(xm[80+z]);
			if (didpatternx.at(j)) continue;
			didpatternx.at(j)=true;
			smps << endl << basefilename << "_PSG" << (i+1) << "_p" << j << ':' << endl;
			ushort previousnote=0;
			ushort previousdur=0;
			ushort dur=0;
			ushort note=0x67;
			ushort currentvoice=0xFFFF;
			ushort lastopt = 0;			
			for (ushort x=0; x<(ushort)(xmdata.at(j).at(xmchannel).size()); x+=5) {
				if (!(xmdata.at(j).at(xmchannel).at(x))) dur++;
				else {
					if (dur) {

						if (dur==previousdur) {
							lastopt=1;
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;							}
						else if (note==previousnote && lastopt!=1) {
							lastopt=2;
							smps << "\tdc.b\t\t$";
							while (dur>0x7F) {
								smps << "7F,smpsNoAttack,$";
								dur-=0x7F;
							}
										
							smps << dur << endl;
						}
						else	{
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";								lastopt=0;
							while (dur>0x7F) {
								smps << "7F,smpsNoAttack,$";
								dur-=0x7F;
							}
							smps << dur << endl;
						}
						
					}
					ushort notebyte = xmdata.at(j).at(xmchannel).at(x);
					ushort instr = xmdata.at(j).at(xmchannel).at(x+1);
					ushort volume = xmdata.at(j).at(xmchannel).at(x+2);
					ushort effect = xmdata.at(j).at(xmchannel).at(x+3);
					ushort efedat = xmdata.at(j).at(xmchannel).at(x+4);
					ushort voice;
					if (chkPSGNoteNums->isChecked()) {					
						voice = (!noisevoices.at(notebyte-1))+1;			
					}
					else
						voice = (!noisevoices.at(instr-1))+1;
					if ((voice!=currentvoice) && instr) {
						smps << "\tsmpsPSGvoice\t$" << voice << endl;
						currentvoice=voice;
					}
					
					if (((effect == 3) && (efedat == 0xFF)) || (volume == 0xFF))	
						smps << "\tdc.b\t\tsmpsNoAttack ; max-speed portamento" << endl;
					previousdur=dur;
					previousnote=note;
					dur=1;
					note = ((xmdata.at(j).at(xmchannel).at(x) == 0x61) ? 0x61 : 2); 
					// Noise note is $82 when pitch = $DC
				}
					
			}
			
			
			if (dur==previousdur)
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;
			else if (note==previousnote && lastopt!=1) {
				smps << "\tdc.b\t\t$";
				while (dur>0x7F) {
					smps << "7F,smpsNoAttack,$";
					dur-=0x7F;
				}
				
				smps << dur << endl;
			}
			else	{
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";
				while (dur>0x7F) {
					smps << "7F,smpsNoAttack,$";
					dur-=0x7F;
				}
				smps << dur << endl;
			}

			smps << "\tsmpsReturn" << endl;
		}
	}	
	// Let's start converting the DAC!
	// Reference: xmdata.at(pattern).at(channel).at(byte)
	if (chkDAC->isChecked()) {

		ushort xmchannel = dacchannelid;

		smps << "\n; Pattern data for DAC";				
		
		QValueVector<bool> didpatternx;
		didpatternx.resize(numpatterns);
		for (ushort z=0; z<xm[64]; ++z) {
		    
			ushort j=eqpattern.at(xmchannel).at(xm[80+z]);
			if (didpatternx.at(j)) continue;
			didpatternx.at(j)=true;
			smps << endl << basefilename << "_DAC" << "_p" << j << ':' << endl;
			ushort previousnote=0xFF;
			ushort previousdur=0;
			ushort dur=0;
			ushort note=0; // DAC starts with a rest instead of E7.
			ushort panning = 4;
			ushort lastopt = 0;						
			for (ushort x=0; x<(ushort)(xmdata.at(j).at(xmchannel).size()); x+=5) {
				if (!(xmdata.at(j).at(xmchannel).at(x))) dur++;
				else {
					if (dur) {

						if (dur==previousdur) {
							lastopt=1;
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;							}
						else if (note==previousnote  && lastopt!=1) {
							lastopt=2;
							smps << "\tdc.b\t\t$";
							while (dur>0x7F) {
								smps << "7F,nRst,$";
								dur-=0x7F;
								previousnote=0x61; 
								// Set note to rest, since we just played one
							}
										
							smps << dur << endl;
						}
						else	{
							smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";								lastopt=0;
							while (dur>0x7F) {
								smps << "7F,nRst,$";
								dur-=0x7F;
								previousnote=0x61; 
								// Set note to rest, since we just played one
								
							}
							smps << dur << endl;
						}
						
					}
					ushort notebyte = xmdata.at(j).at(xmchannel).at(x);
					ushort instr = xmdata.at(j).at(xmchannel).at(x+1);
					ushort volume = xmdata.at(j).at(xmchannel).at(x+2);
					ushort effect = xmdata.at(j).at(xmchannel).at(x+3);
					ushort efedat = xmdata.at(j).at(xmchannel).at(x+4);

					
					if (dacxmpan && ((effect == 8) || (effect == 0) || ((volume&0xF0)==0xC0))) {
						ushort outpan=1;
						if (effect&(efedat<0x7F)) outpan = 0;
						if (effect&(efedat>0x80)) outpan = 2;
						if (volume>0xC8) outpan = 2;
						if ((volume>=0xC0)&&(volume<0xC7)) outpan = 0;
						if (outpan!=panning) {
							panning=outpan;
							switch(panning) {
							case 0:
								smps << "\tsmpsPan\t\tpanLeft,0" << endl;
								break;
							case 1:
								smps << "\tsmpsPan\t\tpanCentre,0" << endl; // Hi Marc
								break;
							case 2:
								smps << "\tsmpsPan\t\tpanRight,0" << endl;
								break;
							}
						}
							
					}
					previousdur=dur;
					previousnote=note;
					dur=1;

					if (chkNoteNums->isChecked())
						note = dacsamples.at(notebyte-1)+1;
					else
					    if (instr)
						note = dacsamples.at(instr-1)+1;
					if (notebyte == 0x61) note=0x61;
				}
					
			}
			
			
			if (dur==previousdur)
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << endl;
			else if (note==previousnote && lastopt!=1) {
				smps << "\tdc.b\t\t$";
				while (dur>0x7F) {
					smps << "7F,nRst,$";
					dur-=0x7F;
				}
				
				smps << dur << endl;
			}
			else	{
				smps << "\tdc.b\t\t$" << ((note==0x61) ? 0x80 : note+0x80) << ",$";
				while (dur>0x7F) {
					smps << "7F,nRst,$";
					dur-=0x7F;
				}
				smps << dur << endl;
			}

			smps << "\tsmpsReturn" << endl;
		}
	}
	
	
	
	// Voices, they should go at the end...
	smps << endl << basefilename << "_Voices:";
	for (ushort i=0; i<(ushort)voices.size(); ++i) {
		if (i%0x19) {
			if ((i%0x19)!=0x10)
				smps << ",$" << voices.at(i);
			else
				smps << endl << "\tdc.b\t$" << voices.at(i);
		}
		else {
			if (i) smps << "\t; Voice " << ((i/0x19)-1) << " (" << lstVoicesSong->item((i/0x19)-1)->text() << ')';
			smps << endl << "\tdc.b\t$" << voices.at(i);
		}
	}
	if (voices.size())
	    smps << "\t; Voice " << ((voices.size()/0x19)-1) << " (" << lstVoicesSong->item((voices.size()/0x19)-1)->text() << ')' << endl << "\teven" << endl;
		
	
	smpsf.close();
	
	QFile compasmf("comp.asm");
	compasmf.open(IO_WriteOnly);
	QTextStream compasm(&compasmf);
	compasm << "\tinclude _s1smps2asm_inc.asm\n";
	compasm << "\tinclude \"" << filenamenoext << ".asm\"\n";
	compasmf.close();
	
	QString cmdtorun = "asmx -C 68K -b 0 -o \"";
	cmdtorun += filenamenoext + ".bin\"";
	cmdtorun += " comp.asm > xm4smps_asm.log";
	std::system(cmdtorun.latin1()); // Assemble the output file into a binary
	QFile outfile(filenamenoext + ".bin");
	int binsize = outfile.size();
	if (binsize)
	    QMessageBox::information(this,"Done","Conversion complete. You should find the converted song as '" + basefilestr + ".asm and '" + basefilestr + ".bin' in the XM's directory.\nBinary size: " + itoa(binsize) + " ($" + itoa(binsize,16) + ") bytes.");
	else
	    QMessageBox::information(this,"Done","Conversion complete. You should find the converted song as '" + basefilestr + ".asm'. However, it wasn't possible to compile this ASM file. You should check xm4smps_asm.log for more information on why this happened.");
}




void frmMain::radOpenHat_toggled( bool what )
{
    noisevoices.at(lstNoiseInstr->currentItem())=what;	
}





void frmMain::radClosedHat_toggled( bool what )
{
    noisevoices.at(lstNoiseInstr->currentItem())=!what;	
}

void frmMain::radClosedHat_stateChanged(int){}


void frmMain::cmdAddAll_clicked()
{
    /*
    for (ushort i=0; i<(ushort)lstVoicesFile->count(); ++i) {
	lstVoicesFile->setCurrentItem(i);
	cmdAddVoice_clicked();
    }
    */
	uchar currentvsize = voices.size();
	voices.resize(currentvsize+(lstVoicesFile->count()*0x19),0);
	for (uint i=0; i<(lstVoicesFile->count()*0x19); ++i) {
		voices[i+currentvsize]=rawvoices_file[i];
	}
	for (uint i=0; i<lstVoicesFile->count(); ++i) 
	    lstVoicesSong->insertItem(lstVoicesFile->item(i)->text());
    
}


void frmMain::cmdDelAll_released()
{
/*    for (ushort i=0; i<(ushort)lstVoicesSong->count(); ++i) {
	lstVoicesSong->setCurrentItem(0);
	cmdDelVoice_clicked();
    } */
/*    while (lstVoicesSong->count()) {
	msgboxd("Remaining: " + itoa(lstVoicesSong->count()));
	lstVoicesSong->setCurrentItem(0);
	cmdDelVoice_clicked();
    }*/
    voices.resize(0);
    lstVoicesSong->clear();
}


void frmMain::sliderFMs_valueChanged( int x )
{
    sliderFMs_sliderMoved(x);

}


void frmMain::sliderPSGs_valueChanged( int x )
{
    sliderPSGs_sliderMoved(x);
}
